<?php

// Mortgage Loan Calculator widget
//
// Copyright (c) 2008-2010 MLCALC.COM
// http://www.mlcalc.com/free-widgets/mortgage-loan-calculator/wordpress.htm
//
// This is an add-on for WordPress
// http://wordpress.org/
//
// **********************************************************************
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// *****************************************************************

/*
Plugin Name: Mortgage Loan Calculator
Plugin URI: http://www.mlcalc.com/free-widgets/mortgage-loan-calculator/wordpress.htm
Description: Powerful mortgage/loan calculator widget for your blog.
Author: Free Mortgage Tools
Version: 1.3
Author URI: http://www.mlcalc.com/free-widgets/
*/

/* Function: display_mlcalc_widget
	** This function does the actual display of the widget in the sidebar
	**
	** args: $args (environment variables handled automatically by the hook)
	** returns: nothing
*/

define('MLCALC_URL', get_option('siteurl') . '/wp-content/plugins/mortgage-loan-calculator');

function display_mlcalc_widget( $args ) {
	extract( $args );
	$options = get_option( 'widget_mlcalc' );
	$title   = $options['title'];

	echo $before_widget;
	echo $before_title
		 . $title
		 . $after_title;

	display_mlcalc($options);

	echo $after_widget;
}

/* Function: display_mlcalc
	** This function does the actual display of the common part of the widget
	**
	** args: $options - to skip duplicate get_options calls
	** returns: nothing
*/
function display_mlcalc($options = array()) {
	global $mlcalcURL;
	if(empty($options)) $options = get_option( 'widget_mlcalc' );

	$title              = empty( $options['title'] ) ? __('Loan Calculator') : $options['title'];
	$default_calculator = empty( $options['default_calculator'] ) ? 'loan' : $options['default_calculator'];
	$form_size          = empty( $options['form_size'] ) ? 'small' : $options['form_size'];
	$currency_code      = empty( $options['currency_code'] ) ? 'usd' : $options['currency_code'];
	$interest_rate      = empty( $options['interest_rate'] ) ? '5.5' : $options['interest_rate'];
	$purchase_price     = empty( $options['purchase_price'] ) ? '300,000' : $options['purchase_price'];
	$mortgage_term      = empty( $options['mortgage_term'] ) ? '30' : $options['mortgage_term'];
	$down_payment       = empty( $options['down_payment'] ) ? '10' : $options['down_payment'];
	$property_tax       = empty( $options['property_tax'] ) ? '3,000' : $options['property_tax'];
	$property_insurance = empty( $options['property_insurance'] ) ? '1,500' : $options['property_insurance'];
	$pmi                = empty( $options['pmi'] ) ? '0.52' : $options['pmi'];
	$loan_amount        = empty( $options['loan_amount'] ) ? '175,000' : $options['loan_amount'];
	$loan_term          = empty( $options['loan_term'] ) ? '15' : $options['loan_term'];
	$amortization       = empty( $options['amortization'] ) ? 'year_nc' : $options['amortization'];
	$language           = empty( $options['language'] ) ? 'en' : $options['language'];

	if($currency_code == 'eur') $currency_symbol = '&euro;';
	if($currency_code == 'gbp') $currency_symbol = '&pound;';
	if($currency_code == 'usd') $currency_symbol = '$';
	if(empty($currency_symbol)) $currency_symbol = substr($currency_code, 0, 3);

	$display_mortgage_form = $display_loan_form = $display_loan_only = $display_mortgage_only = $display_loan = $display_mortgage = 'style="display:none"';

	switch ($default_calculator){
		case 'mortgage':
			$display_mortgage = $display_mortgage_form = '';
		break;
		case 'loan_only':
			$display_loan_only = $display_loan_form = '';
		break;
		case 'mortgage_only':
			$display_mortgage_only = $display_mortgage_form = '';
		break;
		case 'loan':
		default:
			$display_loan = $display_loan_form = '';
		break;
	}

	$hidden = '';
	$display_amortization = '';

	if ((preg_match('/_nc/i', $amortization)) || $amortization == 'none') {
		$display_amortization = 'style="display:none"';
		$hidden .= '<input type="hidden" name="as" value="' . str_replace('_nc', '', $amortization) . '" />';
	}

	$as_year  = (preg_match('/year/i', $amortization)) ? 'checked="checked"' : '';
	$as_month = (preg_match('/month/i', $amortization)) ? 'checked="checked"' : '';

	?>
		<!-- MLCALC BEGIN -->
		<script type="text/javascript">if(typeof jQuery == "undefined"){document.write(unescape("%3Cscript src='" + (document.location.protocol == 'https:' ? 'https:' : 'http:') + "//ajax.googleapis.com/ajax/libs/jquery/1.3.2/jquery.min.js' type='text/javascript'%3E%3C/script%3E"));mlcalc_jquery_noconflict=1;};</script>
		<script type="text/javascript"><!--
	<?php
	echo "mlcalc_currency_symbol = '$currency_symbol';\r\n";
	echo "mlcalc_amortization    = '$amortization';\r\n";
	echo "--></script>\r\n";
	echo '<script type="text/javascript" src="http://cdn.mlcalc.com'.($language == 'en' ? '' : '/'.$language).'/wordpress/widget-nj.js"></script>'."\r\n";
	include("forms-$language.inc.php");
	echo "<!-- MLCALC END -->\r\n";
}

/* Function: mlcalc_head_data
**
** This function inserts link to CSS file into header
**
** args: nothing
** returns: nothing
*/

function mlcalc_head_data(){
	$options = get_option( 'widget_mlcalc' );
	$form_size = empty( $options['form_size'] ) ? 'small' : $options['form_size'];
	if($form_size == 'small'){
		echo '<link type="text/css" rel="stylesheet" href="http://cdn.mlcalc.com/themes/mlcalc/widget-form-small.css" />';
	} else {
		echo '<link type="text/css" rel="stylesheet" href="http://cdn.mlcalc.com/themes/mlcalc/widget-form.css" />';
	}
}

/* Function: mlcalc_control
**
** This function draws the controls form on the widget page and
** saves the settings when the "Save" button is clicked
**
** args: nothing
** returns: nothing
*/

function mlcalc_control() {
	$options = $newoptions = get_option('widget_mlcalc');

	if ( $_POST['mlcalc-submit'] ) {
		$newoptions['title']              = strip_tags(stripslashes($_POST['mlcalc-title']));
		$newoptions['default_calculator'] = strip_tags(stripslashes($_POST['mlcalc-default_calculator']));
		$newoptions['form_size']          = strip_tags(stripslashes($_POST['mlcalc-form_size']));
		$newoptions['currency_code']      = strip_tags(stripslashes($_POST['mlcalc-currency_code']));
		$newoptions['interest_rate']      = strip_tags(stripslashes($_POST['mlcalc-interest_rate']));
		$newoptions['purchase_price']     = strip_tags(stripslashes($_POST['mlcalc-purchase_price']));
		$newoptions['mortgage_term']      = strip_tags(stripslashes($_POST['mlcalc-mortgage_term']));
		$newoptions['down_payment']       = strip_tags(stripslashes($_POST['mlcalc-down_payment']));
		$newoptions['property_tax']       = strip_tags(stripslashes($_POST['mlcalc-property_tax']));
		$newoptions['property_insurance'] = strip_tags(stripslashes($_POST['mlcalc-property_insurance']));
		$newoptions['pmi']                = strip_tags(stripslashes($_POST['mlcalc-pmi']));
		$newoptions['loan_amount']        = strip_tags(stripslashes($_POST['mlcalc-loan_amount']));
		$newoptions['loan_term']          = strip_tags(stripslashes($_POST['mlcalc-loan_term']));
		$newoptions['amortization']       = strip_tags(stripslashes($_POST['mlcalc-amortization']));
		$newoptions['language']          = strip_tags(stripslashes($_POST['mlcalc-language']));
	}
	if ( $options != $newoptions ) {
		$options = $newoptions;
		update_option('widget_mlcalc', $options);
	}

	$title = attribute_escape($options['title']);
	$default_calculator = attribute_escape($options['default_calculator']);
	$form_size = attribute_escape($options['form_size']);
	$currency_code = attribute_escape($options['currency_code']);
	$interest_rate = attribute_escape($options['interest_rate']);
	$purchase_price = attribute_escape($options['purchase_price']);
	$mortgage_term = attribute_escape($options['mortgage_term']);
	$down_payment = attribute_escape($options['down_payment']);
	$property_tax = attribute_escape($options['property_tax']);
	$property_insurance = attribute_escape($options['property_insurance']);
	$pmi = attribute_escape($options['pmi']);
	$loan_amount = attribute_escape($options['loan_amount']);
	$loan_term = attribute_escape($options['loan_term']);
	$amortization = attribute_escape($options['amortization']);
	$language = attribute_escape($options['language']);
?>
		<p><label for="mlcalc-title"><?php _e('Title:'); ?> <input class="widefat" id="mlcalc-title" name="mlcalc-title" type="text" value="<?php echo $title; ?>" /></label></p>
		<p>
			<label for="mlcalc-default_calculator"><?php _e( 'Calculator:' ); ?>
				<select name="mlcalc-default_calculator" id="mlcalc-default_calculator" class="widefat">
					<option value="loan"<?php selected( $options['default_calculator'], 'loan' ); ?>><?php _e('Loan by Default'); ?></option>
					<option value="loan_only"<?php selected( $options['default_calculator'], 'loan_only' ); ?>><?php _e('Loan Only'); ?></option>
					<option value="mortgage"<?php selected( $options['default_calculator'], 'mortgage' ); ?>><?php _e('Mortgage by Default'); ?></option>
					<option value="mortgage_only"<?php selected( $options['default_calculator'], 'mortgage_only' ); ?>><?php _e('Mortgage Only'); ?></option>
				</select>
			</label>
		</p>
		<p>
			<label for="mlcalc-form_size"><?php _e( 'Form size:' ); ?>
				<select name="mlcalc-form_size" id="mlcalc-form_size" class="widefat">
					<option value="small"<?php selected( $options['form_size'], 'small' ); ?>><?php _e('Narrow (width = 150px)'); ?></option>
					<option value="big"<?php selected( $options['form_size'], 'big' ); ?>><?php _e('Wide (width = 300px)'); ?></option>
				</select>
			</label>
		</p>
		<p>
			<label for="mlcalc-amortization"><?php _e( 'Amortization:' ); ?>
				<select name="mlcalc-amortization" id="mlcalc-amortization" class="widefat">
					<option value="year_nc"<?php selected( $options['amortization'], 'year_nc' ); ?>><?php _e('Show by year (no selector)'); ?></option>
					<option value="month_nc"<?php selected( $options['amortization'], 'month_nc' ); ?>><?php _e('Show by month (no selector)'); ?></option>
					<option value="year"<?php selected( $options['amortization'], 'year' ); ?>><?php _e('Show by year'); ?></option>
					<option value="month"<?php selected( $options['amortization'], 'month' ); ?>><?php _e('Show by month'); ?></option>
					<option value="none"<?php selected( $options['amortization'], 'none' ); ?>><?php _e('Don\'t show'); ?></option>
				</select>
			</label>
		</p>
		<p>
			<label for="mlcalc-language"><?php _e( 'Language:' ); ?>
				<select name="mlcalc-language" id="mlcalc-language" class="widefat">
					<option value="en"<?php selected( $options['language'], 'en' ); ?>>English</option>
					<option value="de"<?php selected( $options['language'], 'de' ); ?>>Deutsch</option>
					<option value="es"<?php selected( $options['language'], 'es' ); ?>>Espa&#241;ol</option>
					<option value="fr"<?php selected( $options['language'], 'fr' ); ?>>Fran&#231;ais</option>
					<option value="it"<?php selected( $options['language'], 'it' ); ?>>Italiana</option>
					<option value="pt"<?php selected( $options['language'], 'pt' ); ?>>Portugu&#234;s</option>
					<option value="ru"<?php selected( $options['language'], 'ru' ); ?>>&#1056;&#1091;&#1089;&#1089;&#1082;&#1080;&#1081;</option>
				</select>
			</label>
		</p>
		<p>
			<label for="mlcalc-currency_code"><?php _e( 'Currency symbol:' ); ?>
				<select name="mlcalc-currency_code" id="mlcalc-currency_code" class="widefat">
					<option value="usd"<?php selected( $options['currency_code'], 'usd' ); ?>><?php _e('USD ($)'); ?></option>
					<option value="eur"<?php selected( $options['currency_code'], 'eur' ); ?>><?php _e('EUR (&euro;)'); ?></option>
					<option value="gbp"<?php selected( $options['currency_code'], 'gbp' ); ?>><?php _e('GBP (&pound;)'); ?></option>
					<option value="R"<?php selected( $options['currency_code'], 'R' ); ?>><?php _e('R'); ?></option>
					<option value="Rp"<?php selected( $options['currency_code'], 'Rp' ); ?>><?php _e('Rp'); ?></option>
					<option value="AED"<?php selected( $options['currency_code'], 'AED' ); ?>><?php _e('AED'); ?></option>
					<option value="Php"<?php selected( $options['currency_code'], 'Php' ); ?>><?php _e('Php'); ?></option>
				</select>
			</label>
		</p>
		<p><a href="#" onclick="(typeof jQuery != 'undefined') ? jQuery('.mlcalc_default_values').show() : document.getElementById('mlcalc_default_values').style.display = 'inline'; this.style.display = 'none'; return false;">Change default values...</a></p>
		<span style="display:none" id="mlcalc_default_values" class="mlcalc_default_values">
		<p><label for="mlcalc-purchase_price"><?php _e( 'Purchase price' ); ?>: <br /> <input style="width: 65px; text-align: center;" type="text" value="<?php echo $purchase_price; ?>" name="mlcalc-purchase_price" id="mlcalc-purchase_price" /> $</label></p>
		<p><label for="mlcalc-down_payment"><?php _e( 'Down payment' ); ?> <small>(<a href="#" onclick="(typeof jQuery != 'undefined') ? jQuery('.mlcalc-down_payment').val('null') : document.getElementById('mlcalc-down_payment').value='null'; return false;">hide this field</a>)</small>: <br /> <input style="width: 35px; text-align: center;" type="text" value="<?php echo $down_payment; ?>" name="mlcalc-down_payment" id="mlcalc-down_payment" class="mlcalc-down_payment" /> %</label></p>
		<p><label for="mlcalc-mortgage_term"><?php _e( 'Mortgage term' ); ?>: <br /> <input style="width: 35px; text-align: center;" type="text" value="<?php echo $mortgage_term; ?>" name="mlcalc-mortgage_term" id="mlcalc-mortgage_term" /> years</label></p>
		<p><label for="mlcalc-interest_rate"><?php _e( 'Interest rate' ); ?>: <br /> <input style="width: 35px; text-align: center;" type="text" value="<?php echo $interest_rate; ?>" name="mlcalc-interest_rate" id="mlcalc-interest_rate" /> %</label></p>
		<p><label for="mlcalc-property_tax"><?php _e( 'Property tax' ); ?> <small>(<a href="#" onclick="(typeof jQuery != 'undefined') ? jQuery('.mlcalc-property_tax').val('null') : document.getElementById('mlcalc-property_tax').value='null'; return false;">hide this field</a>)</small>: <br /> <input style="width: 65px; text-align: center;" type="text" value="<?php echo $property_tax; ?>" name="mlcalc-property_tax" id="mlcalc-property_tax" class="mlcalc-property_tax" /> $ per year</label></p>
		<p><label for="mlcalc-property_insurance"><?php _e( 'Property insurance' ); ?> <small>(<a href="#" onclick="(typeof jQuery != 'undefined') ? jQuery('.mlcalc-property_insurance').val('null') : document.getElementById('mlcalc-property_insurance').value='null'; return false;">hide this field</a>)</small>: <br /> <input style="width: 65px; text-align: center;" type="text" value="<?php echo $property_insurance; ?>" name="mlcalc-property_insurance" id="mlcalc-property_insurance" class="mlcalc-property_insurance" /> $ per year</label></p>
		<p><label for="mlcalc-pmi"><?php _e( 'PMI' ); ?> <small>(<a href="#" onclick="(typeof jQuery != 'undefined') ? jQuery('.mlcalc-pmi').val('null') : document.getElementById('mlcalc-pmi').value='null'; return false;">hide this field</a>)</small>: <br /> <input style="width: 35px; text-align: center;" type="text" value="<?php echo $pmi; ?>" name="mlcalc-pmi" id="mlcalc-pmi" class="mlcalc-pmi" /> %</label></p>
		<p><label for="mlcalc-loan_amount"><?php _e( 'Loan amount' ); ?>: <br /> <input style="width: 65px; text-align: center;" type="text" value="<?php echo $loan_amount; ?>" name="mlcalc-loan_amount" id="mlcalc-loan_amount" /> $</label></p>
		<p><label for="mlcalc-loan_term"><?php _e( 'Loan term' ); ?>: <br /> <input style="width: 35px; text-align: center;" type="text" value="<?php echo $loan_term; ?>" name="mlcalc-loan_term" id="mlcalc-loan_term" /> years</label></p>
		</span>

		<input type="hidden" id="mlcalc-submit" name="mlcalc-submit" value="1" />
<?php
}

/* Function: mlcalc_register
**
** Registers the MLCALC widget with the widget page
**
** args: none
** returns: nothing
*/

function mlcalc_register() {
	$widget_ops = array('classname' => 'widget_mlcalc', 'description' => __('Mortgage and loan calculator'));
	$name = __('M/L Calculator');

	wp_register_sidebar_widget( 'mlcalc', $name, 'display_mlcalc_widget', $widget_ops );
	wp_register_widget_control( 'mlcalc', $name, 'mlcalc_control' );
}

// This is important
add_action( 'widgets_init', 'mlcalc_register' );
add_action( 'wp_head', 'mlcalc_head_data' );


?>